import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkGate, ThinkGateParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkGate(params: ThinkGateParam) {
  const res = await request.get<ApiResult<PageResult<ThinkGate>>>(
    THINK_API_URL + '/think/think-gate/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkGate(params?: ThinkGateParam) {
  const res = await request.get<ApiResult<ThinkGate[]>>(
    THINK_API_URL + '/think/think-gate',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkGate(data: ThinkGate) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-gate',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkGate(data: ThinkGate) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-gate',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkGate(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-gate/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkGate(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-gate/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkGate(id: number) {
  const res = await request.get<ApiResult<ThinkGate>>(
    THINK_API_URL + '/think/think-gate/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
